; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_INITIALISIERUNG:
	sbi (MOTOR_AUF_DDR),(MOTOR_AUF_PIN_NR)	; auf Ausgang	
	sbi (MOTOR_ZU_DDR) ,(MOTOR_ZU_PIN_NR)	; auf Ausgang	
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW			
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei ca. 1kHz piept er am lautesten :-)										
MOTOR_BEEP:
	ldi XL,LOW (400)
	ldi XH,HIGH(400)
MOTOR_BEEP_s:
	WDR
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	sbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call WAIT_500us
	sbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call WAIT_500us
	sbiw XL,1
	tst XL
	brne MOTOR_BEEP_s
	tst XH
	brne MOTOR_BEEP_s
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Pull UPs aus, da REFLEXLICHTSCHRANKE nur wenig Strom schalten kann !			
MOTOR_REFLEXLICHTSCHRANKE_ON:
	sbi (REFLEX_POWER_DDR) ,(REFLEX_POWER_PIN_NR)	; auf Ausgang	
	sbi (REFLEX_POWERX_DDR),(REFLEX_POWERX_PIN_NR)	; auf Ausgang	
	sbi (REFLEX_POWER_PORT) ,(REFLEX_POWER_PIN_NR)	; HIGH			
	sbi (REFLEX_POWERX_PORT),(REFLEX_POWERX_PIN_NR)	; HIGH			
	cbi (REFLEX_DDR) ,(REFLEX_PIN_NR)				; auf EINGANG	
	cbi (REFLEX_PORT),(REFLEX_PIN_NR)				; Pull-UP aus	
	call WAIT_50ms					; PAUSE, sonst ev. Fehlimpulse	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_REFLEXLICHTSCHRANKE_OFF:
	cbi (REFLEX_POWER_DDR) ,(REFLEX_POWER_PIN_NR)	; auf EINGANG	
	cbi (REFLEX_POWERX_DDR),(REFLEX_POWERX_PIN_NR)	; auf EINGANG	
	cbi (REFLEX_POWER_PORT) ,(REFLEX_POWER_PIN_NR)	; Pull-UP aus	
	cbi (REFLEX_POWERX_PORT),(REFLEX_POWERX_PIN_NR)	; Pull-UP aus	
	cbi (REFLEX_DDR) ,(REFLEX_PIN_NR)				; auf EINGANG	
	cbi (REFLEX_PORT),(REFLEX_PIN_NR)				; Pull-UP aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_AUF:
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW						
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW						
	call MOTOR_REFLEXLICHTSCHRANKE_ON		; REX ON					
	STS(adr_MOTOR_DREHRICHTUNG),EINS 		; (1)			
	sbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; HIGH			
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_ZU:
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW						
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW						
	call MOTOR_REFLEXLICHTSCHRANKE_ON		; REX ON					
	STS(adr_MOTOR_DREHRICHTUNG),VOLL		; (-1)			
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW			
	sbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; HIGH			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; lst Laufzeitberwachung aus													
MOTOR_STOP:
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW						
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW						
	STS(adr_MOTOR_POSITION_SOLL_L),VOLL		; wichtig					
	STS(adr_MOTOR_POSITION_SOLL_H),VOLL		; wichtig					
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_POSITION_LADEN_TEMP1_2:
	cli 							;Global Interrupt Disable	
	LDS temp1,(adr_MOTOR_POSITION_IST_L)
	LDS temp2,(adr_MOTOR_POSITION_IST_H)
	sei 							; Global Interrupt Enable	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_WAIT:
	WDR
	call TASTATUR_ABFRAGE
	call MOTOR_POSITION_LADEN_TEMP1_2
	call LCD_ZAHL_TEMP1_2
	LDS temp,(adr_MOTOR_DREHRICHTUNG)
	tst temp
	brne MOTOR_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; komlett zu																	
MOTOR_POSITION_NULL:
	call TEXT_NULL
	call MOTOR_AUF			; 1s auf			
	call WAIT_1s
	call MOTOR_STOP
	call MOTOR_WAIT
	call WAIT_1s
;-------------------------------------------------------------------------------
	ldi temp1,LOW (9999)
	ldi temp2,HIGH(9999)
	STS(adr_MOTOR_POSITION_IST_L),temp1
	STS(adr_MOTOR_POSITION_IST_H),temp2
	call MOTOR_ZU			; zu bis Anschlag	
	call MOTOR_WAIT
	call WAIT_2s
	STS(adr_MOTOR_POSITION_IST_L),NULL
	STS(adr_MOTOR_POSITION_IST_H),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_CALIBRIERUNG:
	ldi temp1,LOW (9999)
	ldi temp2,HIGH(9999)
	STS(adr_MOTOR_POSITION_IST_L),temp1
	STS(adr_MOTOR_POSITION_IST_H),temp2
	call MOTOR_ZU			; "zu" bis Anschlag	
	call MOTOR_WAIT
	call WAIT_1s
;-------------------------------------------------------------------------------
	STS(adr_MOTOR_POSITION_IST_L),NULL	; NULL
	STS(adr_MOTOR_POSITION_IST_H),NULL
	call MOTOR_AUF			; "auf" bis Anschlag	
	call MOTOR_WAIT
	call WAIT_1s
	call MOTOR_POSITION_LADEN_TEMP1_2
	STS(adr_MOTOR_POSITION_ENDE_L),temp1
	STS(adr_MOTOR_POSITION_ENDE_H),temp2
	call WAIT_2s
	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_NACH_X:
	STS(adr_MOTOR_POSITION_SOLL_L),XL
	STS(adr_MOTOR_POSITION_SOLL_H),XH
	rcall MOTOR_POSITION_LADEN_TEMP1_2	; Position	
	cp XH,temp2
	breq MOTOR_POS_L
	brsh MOTOR_POS_AUF
	rjmp MOTOR_POS_ZU
MOTOR_POS_L:
	cp XL,temp1
	breq MOTOR_POS_FERTIG
	brsh MOTOR_POS_AUF
	rjmp MOTOR_POS_ZU
;-------------------------------------------------------------------------------
MOTOR_POS_FERTIG:
	ret
;-------------------------------------------------------------------------------
MOTOR_POS_AUF:
	call MOTOR_AUF
ret
;-------------------------------------------------------------------------------
MOTOR_POS_ZU:
	call MOTOR_ZU
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
